Loading...
Searching...
No Matches
BALL::RotamerLibrary Class Reference
Molecular Modeling » Molecular Structure » Rotamers

Rotamer Library Class. More...

`#include <BALL/STRUCTURE/rotamerLibrary.h>`

## Public Member Functions

Constructors and Destructors
| RotamerLibrary ()
| RotamerLibrary (const String &filename, const FragmentDB &fragment_db)
| Detailed constructor, provided for convenience.
| RotamerLibrary (const FragmentDB &fragment_db)
| Detailed constructor.
| RotamerLibrary (const RotamerLibrary &library)
| Copy constructor.
virtual | ~RotamerLibrary ()
| Destructor.
Assignment
RotamerLibrary & | operator= (const RotamerLibrary &rhs)
| Assignment operator.
Accessors
ResidueRotamerSet * | getRotamerSet (const String &name)
| Return the residue set of the residue name.
ResidueRotamerSet * | getRotamerSet (const String &name, float phi, float psi)
| Return the residue set of the given name and torsions.
ResidueRotamerSet * | getRotamerSet (const Residue &residue)
| Return the residue set of the given residue.
Size | getNumberOfRotamers () const
| Return total number of rotamers.
Size | getNumberOfRotamers (const String &name) const
| Return the number of rotamers of the residue with the name.
Size | getNumberOfRotamerSets () const
| returns the number of rotamer sets
void | addRotamer (const String &name, const Rotamer &rotamer, Size number_of_torsions, Index phi, Index psi)
| adds rotamer with specific phi/psi backbone torsion
void | addRotamer (const String &name, const Rotamer &rotamer, Size number_of_torsions)
| adds a rotamer with name
bool | isBackboneDependent () const
| returns true if the rotamers are backbone dependent
void | setBackboneDependent (bool dependent)
| sets whether the rotamers are backbone dependent or not
bool | hasRotamers (const String &name) const
| returns true if the library contains rotamers with this name
bool | validate ()
| method to test the validity of this library, typically called after the building (see SCWRLLibraryFile)
void | sort ()
| method to sort the Rotamers of each ResidueRotamerSet descendingly according to the probability
void | clear ()

## Static Public Attributes

String constants
static const String | DEFAULT_LIBRARY
| Rotamer library used when calling the default constructor.
static const String | DEFAULT_FRAGMENT_DB
| Fragment DB used when calling the default constructor.

## Protected Attributes

HashMap< Index, HashMap< Index, HashMap< String, ResidueRotamerSet > > > | bb_dep_sets_
| Contains the available variants (phi, psi, name, rotamer set) in case of bb dep.
HashMap< String, ResidueRotamerSet > | bb_indep_sets_
| Contains the available variants (name, rotamer set) in case of bb indep.
Size | step_width_
| discretization step width of the torsion angles
FragmentDB | fragment_db_
| fragment db used in this class
bool | backbone_dependent_
| flag which is true when the library has backbone dependent rotamers
Index | getNearestBackboneTorsion_ (double angle) const

## Detailed Description

Rotamer Library Class.

A rotamer library contains a list of possible rotamers for each of the 18 amino acid side chains (GLY and ALA do not have rotamers).

Definition at line 33 of file rotamerLibrary.h.

## Constructor & Destructor Documentation

## RotamerLibrary() [1/4]

BALL::RotamerLibrary::RotamerLibrary | ( |  | ) |

Default constructor. Uses rotamer library RotamerLibrary::DEFAULT_LIBRARY and fragment db RotamerLibrary::DEFAULT_FRAGMENT_DB.

## RotamerLibrary() [2/4]

BALL::RotamerLibrary::RotamerLibrary | ( | const String & | filename,
|  | const FragmentDB & | fragment_db )

Detailed constructor, provided for convenience.

## RotamerLibrary() [3/4]

BALL::RotamerLibrary::RotamerLibrary | ( | const FragmentDB & | fragment_db | ) |

Detailed constructor.

## RotamerLibrary() [4/4]

BALL::RotamerLibrary::RotamerLibrary | ( | const RotamerLibrary & | library | ) |

Copy constructor.

## ~RotamerLibrary()

virtual BALL::RotamerLibrary::~RotamerLibrary | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## addRotamer() [1/2]

void BALL::RotamerLibrary::addRotamer | ( | const String & | name,
|  | const Rotamer & | rotamer,
|  | Size | number_of_torsions )

adds a rotamer with name

## addRotamer() [2/2]

void BALL::RotamerLibrary::addRotamer | ( | const String & | name,
|  | const Rotamer & | rotamer,
|  | Size | number_of_torsions,
|  | Index | phi,
|  | Index | psi )

adds rotamer with specific phi/psi backbone torsion

## clear()

void BALL::RotamerLibrary::clear | ( |  | ) |

Clear rotamer library. Removes all rotamers and sets library to backbone independent.

## getNearestBackboneTorsion_()

Index BALL::RotamerLibrary::getNearestBackboneTorsion_ | ( | double | angle | ) | const

protected

## getNumberOfRotamers() [1/2]

Size BALL::RotamerLibrary::getNumberOfRotamers | ( |  | ) | const

Return total number of rotamers.

## getNumberOfRotamers() [2/2]

Size BALL::RotamerLibrary::getNumberOfRotamers | ( | const String & | name | ) | const

Return the number of rotamers of the residue with the name.

## getNumberOfRotamerSets()

Size BALL::RotamerLibrary::getNumberOfRotamerSets | ( |  | ) | const

returns the number of rotamer sets

## getRotamerSet() [1/3]

ResidueRotamerSet * BALL::RotamerLibrary::getRotamerSet | ( | const Residue & | residue | ) |

Return the residue set of the given residue.

## getRotamerSet() [2/3]

ResidueRotamerSet * BALL::RotamerLibrary::getRotamerSet | ( | const String & | name | ) |

Return the residue set of the residue name.

## getRotamerSet() [3/3]

ResidueRotamerSet * BALL::RotamerLibrary::getRotamerSet | ( | const String & | name,
|  | float | phi,
|  | float | psi )

Return the residue set of the given name and torsions.

## hasRotamers()

bool BALL::RotamerLibrary::hasRotamers | ( | const String & | name | ) | const

returns true if the library contains rotamers with this name

## isBackboneDependent()

bool BALL::RotamerLibrary::isBackboneDependent | ( |  | ) | const

returns true if the rotamers are backbone dependent

## operator=()

RotamerLibrary & BALL::RotamerLibrary::operator= | ( | const RotamerLibrary & | rhs | ) |

Assignment operator.

## setBackboneDependent()

void BALL::RotamerLibrary::setBackboneDependent | ( | bool | dependent | ) |

sets whether the rotamers are backbone dependent or not

## sort()

void BALL::RotamerLibrary::sort | ( |  | ) |

method to sort the Rotamers of each ResidueRotamerSet descendingly according to the probability

## validate()

bool BALL::RotamerLibrary::validate | ( |  | ) |

method to test the validity of this library, typically called after the building (see SCWRLLibraryFile)

## Member Data Documentation

## backbone_dependent_

bool BALL::RotamerLibrary::backbone_dependent_

protected

flag which is true when the library has backbone dependent rotamers

Definition at line 149 of file rotamerLibrary.h.

## bb_dep_sets_

HashMap<Index, HashMap<Index, HashMap<String, ResidueRotamerSet> > > BALL::RotamerLibrary::bb_dep_sets_

protected

Contains the available variants (phi, psi, name, rotamer set) in case of bb dep.

Definition at line 134 of file rotamerLibrary.h.

## bb_indep_sets_

HashMap<String, ResidueRotamerSet> BALL::RotamerLibrary::bb_indep_sets_

protected

Contains the available variants (name, rotamer set) in case of bb indep.

Definition at line 137 of file rotamerLibrary.h.

## DEFAULT_FRAGMENT_DB

const String BALL::RotamerLibrary::DEFAULT_FRAGMENT_DB

static

Fragment DB used when calling the default constructor.

Definition at line 47 of file rotamerLibrary.h.

## DEFAULT_LIBRARY

const String BALL::RotamerLibrary::DEFAULT_LIBRARY

static

Rotamer library used when calling the default constructor.

Definition at line 44 of file rotamerLibrary.h.

## fragment_db_

FragmentDB BALL::RotamerLibrary::fragment_db_

protected

fragment db used in this class

Definition at line 146 of file rotamerLibrary.h.

## step_width_

Size BALL::RotamerLibrary::step_width_

protected

discretization step width of the torsion angles

Definition at line 143 of file rotamerLibrary.h.